from sqlalchemy import create_engine, MetaData, Table, insert, select,update,delete,text
from sqlalchemy.sql import and_, or_
from core import app
import json
from .. import engine

#engine = create_engine(app.config['DATABASE_URI'])
# engine = create_engine(app.config['DATABASE_URI'],pool_size=5000,pool_pre_ping=True,pool_recycle=3600)
# engine = create_engine(app.config['DATABASE_URI'],pool_size=5000,max_overflow=100,pool_pre_ping=True,pool_recycle=3600)
# engine = create_engine(app.config['DATABASE_URI'], poolclass=None,pool_size=5000,max_overflow=100,pool_pre_ping=True,pool_recycle=3600)

class ReminderMailModel():
	def __init__(self):
		try:
			self.meta               = MetaData()
			self.user_status_logs   = Table("user_status_logs", self.meta, autoload_with=engine)
		   
		except Exception as e:
			print(e)
	
	def RejectedData(self,dt_string,society_id):
		with engine.connect() as conn:
			stmt = text("SELECT u.society_id,s.society_key,u.prefix,u.full_name,u.email, usl.user_status_log_id,usl.user_id,usl.status_id,max(usl.created_at) as created_at,usl.reminder_email_count,usl.remarks,usl.next_reminder_date  from user_status_logs usl "+
				" left join users u on u.user_id = usl.user_id left join societies s on s.society_id=u.society_id where u.status_id = 12 and u.full_name is not null and next_reminder_date like '%"+dt_string+"%' and usl.reminder_email_count < 3 group by usl.user_id ")
			results = conn.execute(stmt).all()
			conn.close()
			return [dict(r._mapping) for r in results] if results else None
			
	def update_reminder_logs(self,data,user_status_log_id):
		try:
			with engine.connect() as conn:
				stmt = self.user_status_logs.update().where(self.user_status_logs.c.user_status_log_id.in_([user_status_log_id])).values(data)        
				result = conn.execute(stmt)
				conn.commit()
				conn.close()
				return "success"
		except Exception as e:
			# raise e
			return "fail"

			  
	
	