from sqlalchemy import create_engine, MetaData, Table, insert, select,update,delete,text
from sqlalchemy.sql import and_, or_
from core import app
import json
from .. import engine

#engine = create_engine(app.config['DATABASE_URI'])
# engine = create_engine(app.config['DATABASE_URI'],pool_size=5000,pool_pre_ping=True,pool_recycle=3600)
# engine = create_engine(app.config['DATABASE_URI'], poolclass=None,pool_size=5000,max_overflow=100,pool_pre_ping=True,pool_recycle=3600)

class UserTraining():
	def __init__(self):
		try:
			self.meta               = MetaData()
			self.user_training = Table("user_training", self.meta, autoload_with=engine)
		   
		except Exception as e:
			print(e)
	
	def get_training(self,ut_id):    
		with engine.connect() as conn:
			stmt = select(self.user_training).where(self.user_training.c.ut_id.in_([ut_id]))
			result = conn.execute(stmt).first()
			conn.close()
			if output:
				return dict(output._mapping)
			else:
				return None
	
  
	def delete_training(self,ut_id):
		with engine.connect() as conn:
			stmt = text("delete from user_training WHERE ut_id IN("+str(ut_id)+")")
			result = conn.execute(stmt)
			conn.commit()
			conn.close()
			return result

	# insert or update qualification
	def update_or_insert(self,user_id,ut_id,data):
		with engine.connect() as conn:
			if (int(ut_id) > 0):
				data.pop("created_at")
				stmt = self.user_training.update().where(self.user_training.c.ut_id.in_([ut_id])).values(data)
				result = conn.execute(stmt)
			else :
				# insert block
				result = conn.execute(self.user_training.insert(), data)
			conn.commit()
			stmt = text("select * from  user_training where user_id= "+str(user_id)+";")        
			results = conn.execute(stmt).all()
			conn.close()
			return [dict(r._mapping) for r in results] if results else None


	def count_training_user_id(self,user_id):
		with engine.connect() as conn:
			stmt = text("SELECT COUNT(user_id) as user_id FROM user_training where user_id="+ str(user_id)  +" limit 1;")
			results = conn.execute(stmt).all()
			conn.close()
			return [dict(r._mapping) for r in results] if results else None
			
	def get_training_by_user(self,user_id):
		with engine.connect() as conn:
			stmt = text("select * from user_training where user_id= "+str(user_id)+";")
			results = conn.execute(stmt).all()
			conn.close()
			return  [dict(r._mapping) for r in results] if results else None
