from flask import request, url_for,flash, render_template,jsonify,redirect
from core import app
from flask import url_for
from datetime import datetime, date, time, timedelta
import requests,mandrill,json
from core.library.helper import Helper
from core.model.MembershipMailTemplates import MembershipMailTemplates
from .. import Cryptography,Auth,Helper,RouteGroup

class Mandrill:	

	def sendMail(subject,html,to,mailData,societyData = None):
# 		societyData		= societyData if societyData else Auth.getSociety()
		if societyData:
			bcc_mails 		= societyData['e_backup_mails']
			from_mail_name 	= societyData['e_from_mail_name']
			from_mail_id 	= societyData['e_from_mail_id']
			reply_mail_id 	= societyData['e_reply_mail_id']
			if mailData:
				if mailData.bcc_mails is not  None:
					bcc_mails = mailData.bcc_mails	
				if mailData.from_mail_name is not None :
					from_mail_name = mailData.from_mail_name
				if mailData.from_mail_id is not None :
					from_mail_id = mailData.from_mail_id
				if mailData.reply_mail_id is not None :
					reply_mail_id = mailData.reply_mail_id


			bcc_list = []
			if int(mailData.is_send_backup) == 1:
				
				if bcc_mails:
					for bcc in bcc_mails.split(","):
						bcc_list.append({'email':bcc,'name':to,'type':'to'})
			else:
				pass
		
			if to:
				# XEs1ytJQpEwaZSq25YgB4Q
				# MANDRILL_API_KEY='XEs1ytJQpEwaZSq25YgB4Q' # IP ADDRESS ENABLED
				MANDRILL_API_KEY = societyData['secret_key']
				mandrill_client = mandrill.Mandrill(MANDRILL_API_KEY)

				message = {
					'subject'    : subject, 
					'recipients' : to,
					'from_name'  : from_mail_name,
					'html'       : html, 
					'from_email' : from_mail_id,
					"headers"    : {"Reply-To": reply_mail_id} ,
					'to'         : [{'email':to,'name':to,'type':'to'}]+bcc_list 
					}
				result = mandrill_client.messages.send(message = message,send_async=True)
				return ('success')
			else:
				return ('Email id is blank')
		else:
			return redirect (url_for('member.Home'))
	
	def sendMail_v1(subject,html,to,mailData,societyData = None):
# 		societyData		= societyData if societyData else Auth.getSociety()
		if societyData:
			bcc_mails 		= societyData['e_backup_mails']
			from_mail_name 	= societyData['society_intial']+ ' - Profile Update'
			from_mail_id 	= societyData['e_from_mail_id']
			reply_mail_id 	= societyData['e_reply_mail_id']
			if mailData:
				if mailData.bcc_mails is not  None:
					bcc_mails = mailData.bcc_mails	
				if mailData.from_mail_name is not None :
					from_mail_name = mailData.from_mail_name
				if mailData.from_mail_id is not None :
					from_mail_id = mailData.from_mail_id
				if mailData.reply_mail_id is not None :
					reply_mail_id = mailData.reply_mail_id


			bcc_list = []
			if int(mailData.is_send_backup) == 1:
				
				if bcc_mails:
					for bcc in bcc_mails.split(","):
						bcc_list.append({'email':bcc,'name':to,'type':'to'})
			else:
				pass
		
			if to:
				# XEs1ytJQpEwaZSq25YgB4Q
				# MANDRILL_API_KEY='XEs1ytJQpEwaZSq25YgB4Q' # IP ADDRESS ENABLED
				MANDRILL_API_KEY = societyData['secret_key']
				mandrill_client = mandrill.Mandrill(MANDRILL_API_KEY)

				message = {
					'subject'    : subject, 
					'recipients' : to,
					'from_name'  : from_mail_name,
					'html'       : html, 
					'from_email' : from_mail_id,
					"headers"    : {"Reply-To": reply_mail_id} ,
					'to'         : [{'email':to,'name':to,'type':'to'}]+bcc_list 
					}
				result = mandrill_client.messages.send(message = message,send_async=True)
				return ('success')
			else:
				return ('Email id is blank')
		else:
			return redirect (url_for('member.Home'))
