from flask import request, url_for,flash, render_template,redirect
from core import app
from flask import url_for
from datetime import datetime, date, time, timedelta
import requests,mandrill,json
from core.library.auth import Auth
import sib_api_v3_sdk
from sib_api_v3_sdk.rest import ApiException

class Bravo: 
	def sendbravoMail_v1(subject,html,to,mailData,societyData):
		if societyData:
			# bcc_mails       = confData['e_backup_emails']
			from_mail_name  = societyData['e_from_mail_name']
			from_mail_id    = societyData['e_from_mail_id']
			reply_mail_id   = societyData['e_reply_mail_id']
			bcc = []
			mail_to = []
			if to:
				to_list = list(to.split(","))
				for t in to_list:
					mail_to.append({'email':t})
			
			if mailData and mailData.get('CC'):
				cc = mailData.get('CC')
			else:
				cc = []
			
			bcc_list = []

			if bcc:
				bcc = list(bcc.split(","))
				for i in bcc:
					bcc_list.append({'email':i})
			cc_list = []
			if cc:
				cc = list(cc.split(","))
				for i in cc:
					cc_list.append({'email':i})
			
			configuration = sib_api_v3_sdk.Configuration()
			# configuration.api_key['api-key'] = confData['secret_key']
			configuration.api_key['api-key'] = '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'
			api_instance = sib_api_v3_sdk.TransactionalEmailsApi(sib_api_v3_sdk.ApiClient(configuration))
			sender = {"name":from_mail_name,"email":from_mail_id}
			to = mail_to
			cc = cc_list
			bcc = bcc_list
			reply_to = {"email":reply_mail_id}
			if bcc_list and cc_list:
				send_smtp_email = sib_api_v3_sdk.SendSmtpEmail(to=to, bcc=bcc_list, cc=cc_list, reply_to=reply_to, html_content=html, sender=sender, subject=subject)
			elif bcc_list:
				send_smtp_email = sib_api_v3_sdk.SendSmtpEmail(to=to, bcc=bcc_list, reply_to=reply_to, html_content=html, sender=sender, subject=subject)
			elif cc_list:
				send_smtp_email = sib_api_v3_sdk.SendSmtpEmail(to=to, cc=cc_list, reply_to=reply_to, html_content=html, sender=sender, subject=subject)
			else:
				send_smtp_email = sib_api_v3_sdk.SendSmtpEmail(to=to, reply_to=reply_to, html_content=html, sender=sender, subject=subject)

			try:
				api_response = api_instance.send_transac_email(send_smtp_email)
				print(api_response)
				return("success")
				
			except ApiException as e:
				print("Exception when calling SMTPApi->send_transac_email: %s\n" % e)
				return("fail")

		else:
			return redirect (url_for('user.Home')) 
	
	def sendbravoMail_v2(subject,html,to,bcc,mailData,societyData):
		if societyData:
			# bcc_mails       = confData['e_backup_emails']
			from_mail_name  = societyData['e_from_mail_name']
			from_mail_id    = societyData['e_from_mail_id']
			reply_mail_id   = societyData['e_reply_mail_id']
			
			mail_to = []
			if to:
				to_list = list(to.split(","))
				for t in to_list:
					mail_to.append({'email':t})
			
			if mailData and mailData.get('CC'):
				cc = mailData.get('CC')
			else:
				cc = []
			
			bcc_list = []

			if bcc:
				bcc = list(bcc.split(","))
				for i in bcc:
					bcc_list.append({'email':i})
			cc_list = []
			if cc:
				cc = list(cc.split(","))
				for i in cc:
					cc_list.append({'email':i})
			
			configuration = sib_api_v3_sdk.Configuration()
			# configuration.api_key['api-key'] = confData['secret_key']
			configuration.api_key['api-key'] = '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'
			api_instance = sib_api_v3_sdk.TransactionalEmailsApi(sib_api_v3_sdk.ApiClient(configuration))
			sender = {"name":from_mail_name,"email":from_mail_id}
			to = mail_to
			cc = cc_list
			bcc = bcc_list
			reply_to = {"email":reply_mail_id}
			if bcc_list and cc_list:
				send_smtp_email = sib_api_v3_sdk.SendSmtpEmail(to=to, bcc=bcc_list, cc=cc_list, reply_to=reply_to, html_content=html, sender=sender, subject=subject)
			elif bcc_list:
				send_smtp_email = sib_api_v3_sdk.SendSmtpEmail(to=to, bcc=bcc_list, reply_to=reply_to, html_content=html, sender=sender, subject=subject)
			elif cc_list:
				send_smtp_email = sib_api_v3_sdk.SendSmtpEmail(to=to, cc=cc_list, reply_to=reply_to, html_content=html, sender=sender, subject=subject)
			else:
				send_smtp_email = sib_api_v3_sdk.SendSmtpEmail(to=to, reply_to=reply_to, html_content=html, sender=sender, subject=subject)

			try:
				api_response = api_instance.send_transac_email(send_smtp_email)
				print(api_response)
				return("success")
				
			except ApiException as e:
				print("Exception when calling SMTPApi->send_transac_email: %s\n" % e)
				return("fail")

		else:
			return redirect (url_for('user.Home')) 