from datetime import timedelta


class Config(object):
    DEBUG = False
    TESTING = False
    DATABASE_URI = 'sqlite:///:memory:'

class ProductionConfig(Config):
    
    # DATABASE_URI  = 'mysql+mysqldb://root:@127.0.0.1:3306/numerote_primary_db' # local primary db version2
    # live primary 8gb db
    # DATABASE_URI  = 'mysql+pymysql://numerotech_primary_db:ZpUQPsv+ANMz@148.72.245.80:3306/numerotech_primary_db?charset=utf8mb4'
    DATABASE_URI  = 'mysql+pymysql://numerotech_primary_db:ZpUQPsv+ANMz@207.148.116.149:3306/numerotech_primary_db?charset=utf8mb4'
    #DATABASE_URI  = 'mysql+pymysql://numerote_primary_db:ZpUQPsv+ANMz@190.92.137.198:3306/numerote_primary_db?charset=utf8mb4'
    # DATABASE_URI  = 'mysql+pymysql://numerote_primary_db:ZpUQPsv+ANMz@190.92.137.198:3306/numerote_primary_db_test?charset=utf8mb4'
    
    UPLOAD_PATH   = 'images'
    BASE_URL      = 'http://127.0.0.1:5000'
    UPLOAD_FOLDER = '/static/user_attachment'

    SESSION_COOKIE_DOMAIN = ''
    SESSION_TYPE = 'filesystem'
    ALLOWED_EXTENSIONS = {'txt', 'pdf', 'png', 'jpg', 'jpeg', 'gif'}
    PERMANENT_SESSION_LIFETIME = timedelta(minutes=120)
class DevelopmentConfig(Config):
    DEBUG = True

class SECRET_KEY(Config):
    SECRET_KEY = '5678906567890543346789976565'
 