from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
from core.model.Users import Users
import requests
import datetime
from datetime import timedelta,date,datetime

app = Blueprint('api', __name__)

@app.route('/get_user', methods = ["GET"])
def getUser():
	response   = requests.get(request.host_url)
	email      = request.args.get('email',None)
	society_id = request.args.get('society_id',None)
	if email is None:
		status  = 400
		message = 'Please request valid email id'
	elif society_id is None:
		status  = 400
		message = 'Please request valid society id'
	elif email and society_id is not None:
		status 	= 200
		message = "ok"
	else:
		status 	= 500
		message	= "internal error from server"
	userData   = Users().get_api_data(email,society_id)
	if email and society_id and userData is None :
		data     = {'email' :email,'society_id':society_id,'created_at'  : datetime.now(),'updated_at'  : datetime.now()}
		user_id  = Users().insert_member(data)
		if user_id:
			userData = Users().get_api_data(email,society_id)
	userData = {
		"status"  : status,
		"message" : message,
		"user"    : userData
		}

	return json.dumps(userData)