from core import app
from flask import session,request
from core.model.Society import Society
from core.model.Users import Users

class Auth:

	def check(society_id):
		if session.get('login_'+str(society_id),None):
			return True
		else:
			return False		

	def login(logindata,society_id):
		session['login_'+str(society_id)] = logindata 
		return session.get('login_'+str(society_id),None)

	def user(society_id):
		return session.get('login_'+str(society_id),None)

	def logout(society_id):
		session.pop('login_'+str(society_id), None)
		return True

	def bocheck(society_id):
		data = session.get('login_'+str(society_id),None)
		if data:
			if data.get("is_admin") == 1:
				return True
		return False		

	def bologin(logindata,society_id):
		session['login_'+str(society_id)] = logindata 
		return session.get('login_'+str(society_id),None)

	def bouser(society_id):
		return session.get('login_'+str(society_id),None)



	def setSociety(soceitydata): 
		session['society_'+str(soceitydata['society_id'])] = soceitydata 
		return session.get('society_'+str(soceitydata['society_id']),None)

	def getSociety(society_id):
		return session.get('society_'+str(society_id),None)
		
	def checkSociety(society_id):
		set_society = 1
		if Auth.getSociety(society_id): # if session.get('society')
			if Auth.getSociety(society_id)["app_host"] == request.host:
				set_society = 0
				society = Auth.getSociety(society_id)
		if set_society == 1:
			society = Society().setSociety(request.host)
		if society:
			msg = ""
			society = Auth.setSociety(society)
			return	society,msg
		else:
			msg = "Invalid Link"
			return society,msg	

	def checkSocietybyIdKey(society_id,society_key):
		set_society = 1
		if Auth.getSociety(society_id):
			if Auth.getSociety(society_id)["society_id"] == society_id:
				set_society = 0
				return Auth.getSociety(society_id)
		if set_society == 1:
			society = Society().getSociety(society_id,society_key)
			return	Auth.setSociety(society)
			
	# Bo Layout data start here     
	def get_bo_layout(society_id,conf_id,admin_email,app_type_id):
		layout_data     = []
		sub_layout_data = {}
		layout_data_db  = Users().get_bo_layout_data(society_id,conf_id,admin_email,app_type_id)
		if layout_data_db :
			for item in layout_data_db:
				if item['parent_menu_id'] == 0 :
					layout_data.append(item)

			for item in layout_data_db:
				if item['parent_menu_id'] != 0 :
					sub_layout_data[item["parent_menu_id"]] = sub_layout_data.get(item['parent_menu_id'],[]) + [item]
		data = {"layout_data":layout_data,"sub_layout_data":sub_layout_data,'all_menu_name':layout_data_db}
		return data	

	# def bosetSociety(soceitydata):
	# 	session['society_'+str(soceitydata['society_id'])] = soceitydata 
	# 	return session.get('society_'+str(soceitydata['society_id']),None)

	# def bogetSociety(society_id):
		# return session.get('society_'+str(society_id),None)

	# def bocheckSociety(society_id):
	# 	set_society = 1
	# 	if Auth.bogetSociety(society_id):
	# 		if Auth.bogetSociety(society_id)["app_host"] == request.host:
	# 			set_society = 0
	# 	if set_society == 1:
	# 		society = Society().setSociety(request.host)
	# 		return	Auth.bosetSociety(society)

	# def checkSocietyAssetsbyIdKey(society_id,society_key):
	# 	set_society = 1
	# 	if Auth.getSociety(society_id):
	# 		if Auth.getSociety(society_id)["society_id"] == society_id:
	# 			set_society = 0
	# 	if set_society == 1:
	# 		society = Society().getSociety(society_id,society_key)
	# 		return	Auth.setSociety(society)		

app.jinja_env.globals.update(Auth=Auth)	
