from sqlalchemy import create_engine, MetaData, Table, insert, select,update,delete,text
from sqlalchemy.sql import and_, or_
from core import app
import json
from .. import engine

#engine = create_engine(app.config['DATABASE_URI'])
# engine = create_engine(app.config['DATABASE_URI'],pool_size=5000,pool_pre_ping=True,pool_recycle=3600)
# engine = create_engine(app.config['DATABASE_URI'],pool_size=5000,max_overflow=100,pool_pre_ping=True,pool_recycle=3600)
# engine = create_engine(app.config['DATABASE_URI'], poolclass=None,pool_size=5000,max_overflow=100,pool_pre_ping=True,pool_recycle=3600)


class States():
	def __init__(self):
		try:
			self.meta               = MetaData()
			self.states             = Table("states", self.meta, autoload_with=engine)
			self.districts              = Table("districts", self.meta, autoload_with=engine)
		   
		except Exception as e:
			print(e)
	
	def get_states(self):
		with engine.connect() as conn:
			stmt = text("select * from states")
			results = conn.execute(stmt).all()
			conn.close()
			return  [dict(r._mapping) for r in results] if results else None
	
	def get_states_of_india(self,country_id):
		with engine.connect() as conn:
			stmt = text("select * from states where country_id   = "+str(country_id)+" order by state_name asc;")
			results = conn.execute(stmt).all()
			conn.close()
			return  [dict(r._mapping) for r in results] if results else None
			
	def get_districts(self):
		with engine.connect() as conn:
			stmt = text("select * from districts")
			results = conn.execute(stmt).all()
			conn.close()
			return  [dict(r._mapping) for r in results] if results else None